
#include <amxmodx>
#include <amxmisc>

#define PLUGIN "Block messages in chat"
#define VERSION "1.0"
#define AUTHOR "Zefir"


new g_filename, g_immunity, g_punish
new Array:recl_messages

public plugin_init() {

	register_plugin(PLUGIN, VERSION, AUTHOR)

	g_filename = register_cvar("block_recl_file", "block_recl.txt")
	g_immunity = register_cvar("block_recl_immunity_flags", "a")
	g_punish   = register_cvar("block_recl_punishment", "amx_gag ##i") // this for my Cerberus, gag to end map

	register_clcmd("say",      "check_say")
	register_clcmd("say_team", "check_say")

	recl_messages = ArrayCreate(192, 16)

	read_messages_file()
}

read_messages_file() {

	static dirname[256], filename[256], string[192]
	get_configsdir(dirname, charsmax(dirname))
	get_pcvar_string(g_filename, filename, charsmax(filename))

	format(filename, charsmax(filename), "%s/%s", dirname, filename)
	new file = fopen(filename, "rt")
	if (!file)
		return PLUGIN_CONTINUE


	while (fgets(file, string, charsmax(string))) {
		trim(string)
		if (string[0] == EOS) continue
		ArrayPushString(recl_messages, string)
	}
	return PLUGIN_CONTINUE
}

public check_say(id) {
	static flags[32]
	get_pcvar_string(g_immunity, flags, charsmax(flags))
	if (is_user_bot(id) || is_user_hltv(id) || access(id, read_flags(flags)))
		return PLUGIN_CONTINUE

	static string[192], recl_string[192], i, recl_size, punish[256], name[33], userid[16]
	recl_size = ArraySize(recl_messages)

	read_args(string, charsmax(string))
	trim(string)

	for (i = 0; i < recl_size; i++) {
		ArrayGetString(recl_messages, i, recl_string, charsmax(recl_string))
		if( containi(string, recl_string) > -1 ) {
			get_pcvar_string(g_punish, punish, charsmax(punish))
			if (punish[0] != EOS) {
				num_to_str(get_user_userid(id), userid, charsmax(userid))
				get_user_name(id, name, charsmax(name))
				replace_all_format(punish, charsmax(punish), "#i", userid)
				replace_all_format(punish, charsmax(punish), "#n", name)
				server_cmd(punish)
			}
			return PLUGIN_HANDLED
		}
	}

	return PLUGIN_CONTINUE
}

stock replace_all_format(string[], len, const format_str[], const with[]) {
	new total = 0

	if (format_str[0] != '#' || strlen(format_str) != 2) {
		log_error(AMX_ERR_PARAMS, "format_str length allowed only 2 charapter, you %s is %d charapters", format_str, strlen(format_str))
		return total
	}

	while (replace(string, len, format_str, "%s") != 0) {
		format(string, len, string, with)
		total++
	}
	
	return total
}

